=== examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13...4.0)

# Add all example subdirectories
add_subdirectory(example1)
add_subdirectory(example2)
add_subdirectory(example3)
add_subdirectory(example4)
add_subdirectory(example1_v2)
add_subdirectory(example2_v2)
add_subdirectory(example3_v2)
add_subdirectory(example4_v2)
