=== debian/changelog ===
dlt-daemon (3.0.0-4) unstable; urgency=medium

  * Ignore tests for now (Closes: #1127857)
  * Follow upstream soname bump to libdlt3

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 17 Feb 2026 11:07:45 +0100

dlt-daemon (3.0.0-3) unstable; urgency=medium

  * Ignore sign-compare for i386

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 12 Feb 2026 21:23:30 +0100

dlt-daemon (3.0.0-2) unstable; urgency=medium

  * Also ignore shift-count-overflow for i386 32 bit time_t

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 12 Feb 2026 18:31:45 +0100

dlt-daemon (3.0.0-1) unstable; urgency=medium

  * Add patch 810 and split no-errors with remaining failures
  * New upstream version 3.0.0
  * Bump std-version to 4.7.3, no changes required
  * Add tools for dltv2 protocol
  * Refresh patches for new release
  * Add patch to fix build with new release

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 12 Feb 2026 16:39:14 +0100
